*+
*+
*+    Source Module => D:\SRC\PRINTER\PRB_POP.PRG
*+
*+    Copyright (C) 1997, Phil Barnett. All Rights Reserved Worldwide.
*+
*+    Functions: Procedure POP_MSG()
*+               Procedure CLR_MSG()
*+               Procedure ATTENTION()
*+               Procedure CNT()
*+               Function c()
*+               Function Amaxstrlen()
*+               Function VERIFY()
*+               Function ASK_FOR()
*+               Procedure cls()
*+               Function FULLDATE()
*+
*+    Reformatted by Click! 2.03 on Aug-27-1999 at 10:49 pm
*+
*+

#include "COMMON.CH"
#include "BOX.CH"
#include "SET.CH"

static THISSCRN
static TL
static BOXHIGH

*+
*+
*+    Procedure POP_MSG()
*+
*+    Called from ( prb_pop.prg  )   1 - function verify()
*+                                   1 - function ask_for()
*+                ( sample.prg   )   2 - function align()
*+
*+
*+
procedure POP_MSG( SOME_TXT, MSG_LOGIC, BORDCOLOR, MAINCOLOR )

local MAXLEN
local x
local ARLEN
local INCOLOR
local CROW
local CCOL
local LC

default MSG_LOGIC to .t.

default BORDCOLOR to 'B+/W'
default MAINCOLOR to 'N/W,W+/B'

if !isarray( SOME_TXT )
   SOME_TXT := { SOME_TXT }
endif

ARLEN := len( SOME_TXT )

TL := ( maxrow() / 2 ) - ( ( ARLEN / 2 ) + 2 )

MAXLEN := min( maxcol() - 4, max( Amaxstrlen( SOME_TXT ), 25 ) + 6 )

BOXHIGH  := ARLEN + 2
THISSCRN := savescreen( TL - 2, 0, BOXHIGH + TL + 1, maxcol() )
CROW     := row()
CCOL     := col()

LC := int( ( maxcol() - MAXLEN ) / 2 )

dispbox( TL - 1, LC, BOXHIGH + TL, LC + MAXLEN - 1, B_DOUBLE_SINGLE + ' ', BORDCOLOR )

dispbegin()

INCOLOR := setcolor( MAINCOLOR )

for x := 1 to ARLEN
   CNT( SOME_TXT[ x ], TL + x )
next

dispend()

if MSG_LOGIC
   ATTENTION( 'Press any key to continue', BOXHIGH + TL )
   inkey( 0 )
   restscreen( TL - 2, 0, BOXHIGH + TL + 1, 79, THISSCRN )
   THISSCRN := ''
   devpos( CROW, CCOL )
endif

setcolor( INCOLOR )

return

*+
*+
*+    Procedure CLR_MSG()
*+
*+    Called from ( prb_pop.prg  )   1 - function verify()
*+                                   1 - function ask_for()
*+                ( sample.prg   )   1 - function align()
*+
*+
*+
procedure CLR_MSG()

restscreen( TL - 2, 0, BOXHIGH + TL + 1, 79, THISSCRN )

THISSCRN := ''

return

*+
*+
*+    Procedure ATTENTION()
*+
*+    Called from ( prb_pop.prg  )   1 - procedure pop_msg()
*+
*+
*+
procedure ATTENTION( CSTRING, NLINENUM, CCOLOR )

local COLDCOLOR

default NLINENUM to 24
default CCOLOR to 'GR+/R'

COLDCOLOR := setcolor( CCOLOR )

CSTRING := '  ' + alltrim( CSTRING ) + '  '

devpos( NLINENUM, c( CSTRING ) )

devout( CSTRING )

setcolor( COLDCOLOR )

return

*+
*+
*+    Procedure CNT()
*+
*+    Called from ( prb_pop.prg  )   1 - procedure pop_msg()
*+
*+
*+
procedure CNT( CSTRING, NLINENUM )

devpos( NLINENUM, c( CSTRING ) )

devout( CSTRING )

return

*+
*+
*+    Function c()
*+
*+    Called from ( prb_pop.prg  )   1 - procedure attention()
*+                                   1 - procedure cnt()
*+                                   2 - function ask_for()
*+
*+
*+
function c( CSTRING )

return max( ( maxcol() / 2 ) - int( len( CSTRING ) / 2 ), 0 )

*+
*+
*+    Function Amaxstrlen()
*+
*+    Called from ( prb_pop.prg  )   1 - procedure pop_msg()
*+
*+
*+
function Amaxstrlen( ANARRAY )

local ARLEN
local THISLEN
local max     := 0
local x

if isarray( ANARRAY )

   ARLEN := len( ANARRAY )

   for x := 1 to ARLEN
      THISLEN := len( ANARRAY[ X ] )
      if THISLEN > max
         max := THISLEN
      endif
   next

endif

return max

*+
*+
*+    Function VERIFY()
*+
*+
*+
function VERIFY( SOME_TXT, LNORMANS, YES_PRMPT, NO_PRMPT, BORDCOLOR, MAINCOLOR )

local INCOLOR
local VERI
local ARLEN

default BORDCOLOR to 'W+/R'
default MAINCOLOR to 'W+/R,W+/B'

LNORMANS  := iif( islogic( LNORMANS ), LNORMANS, .t. )
YES_PRMPT := iif( YES_PRMPT = NIL, ' YES ', ' ' + alltrim( YES_PRMPT ) + ' ' )
NO_PRMPT  := iif( NO_PRMPT = NIL, ' NO ', ' ' + alltrim( NO_PRMPT ) + ' ' )

if !isarray( SOME_TXT )
   SOME_TXT := { SOME_TXT }
endif

ARLEN := len( SOME_TXT ) + 2

asize( SOME_TXT, ARLEN )

SOME_TXT[ ARLEN - 1 ] := ''
SOME_TXT[ ARLEN ]     := ''

POP_MSG( SOME_TXT, .f., BORDCOLOR, MAINCOLOR )

VERI := iif( LNORMANS, 1, 2 )

INCOLOR := setcolor( MAINCOLOR )
@ TL - 2 + BOXHIGH, 33 - ( len( YES_PRMPT ) / 2 ) prompt YES_PRMPT
@ TL - 2 + BOXHIGH, 46 - ( len( NO_PRMPT ) / 2 ) prompt NO_PRMPT

menu to VERI

clr_msg()

setcolor( INCOLOR )

return ( VERI == 1 )

*+
*+
*+    Function ASK_FOR()
*+
*+
*+
function ASK_FOR( SOME_TXT, Getvar, PICVAR, BORDCOLOR, MAINCOLOR )

local GETLIST := {}

local INCOLOR  := setcolor()
local INCURSOR := set( _SET_CURSOR )
local ARLEN
local VCNT
local RETVAL
local CROW     := row()
local CCOL     := col()

default BORDCOLOR to 'G+/GR'
default MAINCOLOR to 'GR+/GR,W+/B,,,W+/N'

if !isarray( SOME_TXT )
   SOME_TXT := { SOME_TXT }
endif

ARLEN := len( SOME_TXT ) + 2

asize( SOME_TXT, ARLEN )

do case
case ischaracter( Getvar )
   VCNT := c( Getvar )
case isdate( Getvar )
   VCNT := 35
case isnumber( Getvar )
   VCNT := c( PICVAR )
otherwise
   VCNT := maxcol() / 2
endcase

SOME_TXT[ ARLEN - 1 ] := ''
SOME_TXT[ ARLEN ]     := space( ( ( maxcol() / 2 ) - VCNT ) * 2 )

POP_MSG( SOME_TXT, .f., BORDCOLOR, MAINCOLOR )

setcolor( MAINCOLOR )

if isdate( Getvar )
   @ TL + BOXHIGH - 2, VCNT get Getvar         
else
   @ TL + BOXHIGH - 2, VCNT get Getvar picture PICVAR        
endif

set cursor ( .t. )
read
set( _SET_CURSOR, INCURSOR )

clr_msg()

RETVAL := Getvar

if ischaracter( Getvar )
   Getvar := alltrim( Getvar )
endif

setcolor( INCOLOR )
devpos( CROW, CCOL )

return RETVAL

*+
*+
*+    Procedure cls()
*+
*+
*+
procedure cls( NEWCOLOR, BKGCHR )

default NEWCOLOR to 'GB+/N,R/W,,,W+/N'
default BKGCHR to 177

setcolor( NEWCOLOR )

dispbox( 0, 0, maxrow(), maxcol(), replicate( chr( BKGCHR ), 9 ) )

return

*+
*+
*+    Function FULLDATE()
*+
*+
*+
function FULLDATE( ANYDATE )

default ANYDATE to date()

return cmonth( ANYDATE ) + ' ' + ltrim( str( day( ANYDATE ), 2 ) ) + ', ' + str( year( ANYDATE ), 4 )

*+ EOF: PRB_POP.PRG
