/*

PRINTER.CH

This file is the key to easily placing the printer codes in your programs.

It is used by the preprocessor to replace your printer tokens with the    
correct accessor function.

These codes are examples. If you have been using particular variables
for printer codes, use them here in the appropriate places.

There is no need to change them if you are just starting out, but
existing programs may need to be 'rewired' here.

*/   


#xtranslate  YOUR_PRINTER =>    P_CODE(1)   // The name of the printer

#xtranslate    CPI10S     =>    P_CODE(2)   // Start 10 CPI 
#xtranslate    NORMAL     =>    P_CODE(2)   // Start 10 CPI

#xtranslate    CPI12E     =>    P_CODE(3)   // End   12 CPI
#xtranslate    E12IN      =>    P_CODE(3)   // End   12 CPI
#xtranslate    CPI12S     =>    P_CODE(4)   // Start 12 CPI
#xtranslate    S12IN      =>    P_CODE(4)   // Start 12 CPI

#xtranslate    CPI15E     =>    P_CODE(5)   // End   15 CPI
#xtranslate    E15IN      =>    P_CODE(5)   // End   15 CPI
#xtranslate    CPI15S     =>    P_CODE(6)   // Start 15 CPI
#xtranslate    S15IN      =>    P_CODE(6)   // Start 15 CPI

#xtranslate    CPI17E     =>    P_CODE(7)   // End   17 CPI
#xtranslate    E17IN      =>    P_CODE(7)   // End   17 CPI
#xtranslate    CPI17S     =>    P_CODE(8)   // Start 17 CPI
#xtranslate    S17IN      =>    P_CODE(8)   // Start 17 CPI

#xtranslate    BPE        =>    P_CODE(9)   // Bold Print End
#xtranslate    EBP        =>    P_CODE(9)   // Bold Print End
#xtranslate    BPS        =>    P_CODE(10)  // Bold Print Start
#xtranslate    SBP        =>    P_CODE(10)  // Bold Print Start

#xtranslate    CLEARALL   =>    P_CODE(11)  // Printer Software Reset Code
#xtranslate    CODECLEAR  =>    P_CODE(11)  // Printer Software Reset Code

#xtranslate    DHE        =>    P_CODE(12)  // Double Height End
#xtranslate    EDH        =>    P_CODE(12)  // Double Height End
#xtranslate    DHS        =>    P_CODE(13)  // Double Height Start
#xtranslate    SDH        =>    P_CODE(13)  // Double Height Start

#xtranslate    DSE        =>    P_CODE(14)  // Double Strike End
#xtranslate    DSS        =>    P_CODE(15)  // Double Strike Start

#xtranslate    EPE        =>    P_CODE(16)  // Elongated Print End
#xtranslate    EEP        =>    P_CODE(16)  // Elongated Print End
#xtranslate    EPS        =>    P_CODE(17)  // Elongated Print Start
#xtranslate    SEP        =>    P_CODE(17)  // Elongated Print Start

#xtranslate    IPE        =>    P_CODE(18)  // Italic Print End
#xtranslate    EIP        =>    P_CODE(18)  // Italic Print End
#xtranslate    IPS        =>    P_CODE(19)  // Italic Print Start
#xtranslate    SIP        =>    P_CODE(19)  // Italic Print Start

#xtranslate    JC         =>    P_CODE(20)  // Justify Center
#xtranslate    JF         =>    P_CODE(21)  // Justify Full
#xtranslate    JL         =>    P_CODE(22)  // Justify Left
#xtranslate    JR         =>    P_CODE(23)  // Justify Right

#xtranslate    LPI6       =>    P_CODE(24)  // 6 Lines Per Inch 
#xtranslate    LPI8       =>    P_CODE(25)  // 8 Lines Per Inch 

#xtranslate    LQE        =>    P_CODE(26)  // Letter Quality End 
#xtranslate    ELQ        =>    P_CODE(26)  // Letter Quality End 
#xtranslate    LQS        =>    P_CODE(27)  // Letter Quailty Start
#xtranslate    SLQ        =>    P_CODE(27)  // Letter Quailty Start

#xtranslate    ML03       =>    P_CODE(28)  // Margin Left 03
#xtranslate    ML05       =>    P_CODE(29)  //             05
#xtranslate    ML10       =>    P_CODE(30)  //             10
#xtranslate    ML15       =>    P_CODE(31)  //             15

#xtranslate    MR135      =>    P_CODE(32)  // Margin Right 135
#xtranslate    MR65       =>    P_CODE(33)  //               65
#xtranslate    MR70       =>    P_CODE(34)  //               70
#xtranslate    MR75       =>    P_CODE(35)  //               75
#xtranslate    MR80       =>    P_CODE(36)  //               80

#xtranslate    PL66       =>    P_CODE(37)  // Page Length 66
#xtranslate    PL84       =>    P_CODE(38)  // Page Length 84

#xtranslate    PROFF      =>    P_CODE(39)  // Proportional Off
#xtranslate    PRON       =>    P_CODE(40)  // Proportional On 

#xtranslate    SUBE       =>    P_CODE(41)  // Subscript End    
#xtranslate    SUBS       =>    P_CODE(42)  // Subscript Start  
#xtranslate    SUPE       =>    P_CODE(43)  // Superscript End  
#xtranslate    SUPS       =>    P_CODE(44)  // Superscript Start

#xtranslate    ULE        =>    P_CODE(45)  // Underline End
#xtranslate    EUL        =>    P_CODE(45)  // Underline End
#xtranslate    ULS        =>    P_CODE(46)  // Underline Start
#xtranslate    SUL        =>    P_CODE(46)  // Underline Start

#xtranslate    ISLASER    =>    P_CODE(47)  // Is it a laser?
#xtranslate    ISPOST     =>    P_CODE(48)  // Is it a Postscript?
#xtranslate    INITHP     =>    P_CODE(49)  // HP Init Code to PCL
#xtranslate    INITPS     =>    P_CODE(50)  // Postscript Init Code

#xtranslate    PORTRAIT   =>    P_CODE(51)  // Code to set portrait Mode
#xtranslate    LANDSCAPE  =>    P_CODE(52)  // Code to set landscape Mode

#xtranslate    PR_SUPPORT =>    P_CODE(53)  // Printer Support Phone Number
 
#xtranslate    SUBMIT_BY  =>    P_CODE(54)  // Who submitted this Printer
#xtranslate    FIDO_ADD   =>    P_CODE(55)  // And their address.

// Start and end double size printing (Epson workalikes)

#xtranslate    SDP        =>    P_CODE(17)+P_CODE(13)
#xtranslate    EDP        =>    P_CODE(16)+P_CODE(12)
#xtranslate    SDHDWP     =>    P_CODE(17)+P_CODE(13)
#xtranslate    EDHDWP     =>    P_CODE(16)+P_CODE(12)

// Same as above in italics

#xtranslate    SDPI       =>    P_CODE(17)+P_CODE(13)+P_CODE(19) 
#xtranslate    EDPI       =>    P_CODE(16)+P_CODE(12)+P_CODE(18)
#xtranslate    SDHDWIP    =>    P_CODE(17)+P_CODE(13)+P_CODE(19)
#xtranslate    EDHDWIP    =>    P_CODE(16)+P_CODE(12)+P_CODE(18)

// characters used often

#xtranslate    FULLBLOCK  =>    CHR(219)
#xtranslate    TOPHALF    =>    CHR(223)
#xtranslate    BOTTOMHALF =>    CHR(220)
#xtranslate    DIAMOND    =>    CHR(174)+CHR(175)

// report seperators and headers.

#xtranslate    DOUBLELINE =>    REPLICATE('=',79)
#xtranslate    SINGLELINE =>    REPLICATE('-',79)
#xtranslate    PRINTBAR   =>    REPLICATE(CHR(223),79)
#xtranslate    SUBHEADER  =>    REPLICATE(CHR(223),79)

/*
 *
 *  Slip printer codes start here.
 *  
 */

#xtranslate    SLIP_MODEL =>    S_CODE(1)
#xtranslate    TPSEX      =>    S_CODE(2)
#xtranslate    TPEEX      =>    S_CODE(3)
#xtranslate    TPSUL      =>    S_CODE(4)
#xtranslate    TPEUL      =>    S_CODE(5)
#xtranslate    TPSINV     =>    S_CODE(6)
#xtranslate    TPEINV     =>    S_CODE(7)
#xtranslate    TPSBOLD    =>    S_CODE(8)
#xtranslate    TPEBOLD    =>    S_CODE(9)
#xtranslate    TPSRED     =>    S_CODE(10)
#xtranslate    TPERED     =>    S_CODE(11)
#xtranslate    CASHOPEN   =>    S_CODE(12)
#xtranslate    TPRESET    =>    S_CODE(13)
#xtranslate    HAS_SLIP   =>    S_CODE(14)
#xtranslate    SLIP_WIDTH =>    S_CODE(15)

