*+
*+
*+    Source Module => D:\SRC\PRINTER\SAMPLE.PRG
*+
*+    Copyright (C) 1997, Phil Barnett. All Rights Reserved Worldwide.
*+
*+    Functions: Procedure PRN_TEST()
*+               Procedure PRINT_INIT()
*+               Function P_CODE()
*+               Procedure PR_UNSET()
*+               Procedure PR_RESET()
*+               Procedure PR_HIDE()
*+               Procedure SLIP_INIT()
*+               Function S_CODE()
*+               Procedure SL_UNSET()
*+               Procedure SL_RESET()
*+               Static Function PR_DECODE()
*+               Function ALIGN()
*+
*+       Tables: use PRINTER new
*+               use SLIP new
*+
*+      Indexes: index on upper( printer ) to printer
*+
*+    Reformatted by Click! 2.03 on Aug-27-1999 at 10:49 pm
*+
*+

#include "common.ch"
#include "printer.ch"

static P_CODES[ SIZE_OF_PRINTER_CODE_ARRAY ]
static PRNT_SAVE[ SIZE_OF_PRINTER_CODE_ARRAY ]
static PRNT_HIDE[ SIZE_OF_PRINTER_CODE_ARRAY ]
static S_CODES[ 15 ]
static SLIP_SAVE[ 15 ]

*+
*+
*+    Procedure PRN_TEST()
*+
*+
*+
procedure PRN_TEST

set printer ( .t. )
set console ( .f. )

begin sequence

   print_init()

   if !ALIGN()
      break
   endif

   ? 'Test Printout for Printer '
   ?
   ?
   ? '( 3 skips )'
   ? CPI10S + 'This Line is Printed in 10 Characters Per Inch. It Should Not Over Run This Line'
   ? CPI12S + 'This Line is Printed in 12 Characters Per Inch................. It Should Not Over Run This Line' + CPI12E
   ? CPI15S + 'This Line is Printed in 15 Characters Per Inch......................................... It Should Not Over Run This Line' + CPI15E
   ? CPI17S + 'This Line is Printed in 17 Characters Per Inch......................................................... It Should Not Over Run This Line' + CPI17E
   ? NORMAL + 'Return to Normal Printing'
   ? DSS + 'Double Strike Start ' + DSE + 'then back to Normal'
   ? BPS + 'Bold Print Start ' + BPE + 'then back to Normal'
   ?
   ? DHS + 'Double Height Start ' + DHE + 'then back to Normal'
   ?
   ? EPS + 'Elongated Print Start ' + EPE + 'then back to Normal'
   ? IPS + 'Italic Print Start ' + IPE + 'then back to Normal'
   ? LQS + 'Letter Quality Start ' + LQE + 'then back to Normal'
   ? ULS + 'Underlined Start ' + ULE + 'then back to Normal'
   ? 'Double line'
   ? DOUBLELINE
   ? 'Single line'
   ? SINGLELINE
   ?
   ? SDP + 'Double Height Double Width' + EDP
   ?
   ? SDPI + 'Double Height Double Width Italics' + EDPI
   ? NORMAL

   ? chr( 12 )

end sequence

set printer ( .f. )
set console ( .t. )

return

*+
*+
*+    Procedure PRINT_INIT()
*+
*+    Called from ( sample.prg   )   1 - procedure prn_test()
*+
*+
*+
procedure PRINT_INIT()

local x
local INAREA := select()

field printer

use PRINTER new
if file( 'printer' + ordbagext() )
   set index to printer
else
   index on upper( printer ) to printer
endif

// this should be permanently selected from the users environment, like:
// dbseek( pad( upper( gete( 'LPT' ) ), 30 ) )

// For now, this defaults to HP Laserjet
// Change this to your matching printer while you are testing.

// dbseek( pad( upper( 'EPSON FX' ), 30 ) )
dbseek( pad( upper( 'HP Laserjet 4M  (PC8 Courier)' ), 30 ) )

for x := 1 to 55
   P_CODES[ X ] := PR_DECODE( fieldget( x ) )
next

PRNT_SAVE := aclone( P_CODES )
PRNT_HIDE := aclone( P_CODES )

for x := 1 to 55
   if ischar( PRNT_HIDE[ x ] )
      PRNT_HIDE[ X ] := '' + PRNT_HIDE[ X ] + ''
   endif
next

PRINTER->( dbclosearea() )

select( INAREA )

return

*+
*+
*+    Function P_CODE()
*+
*+
*+
function P_CODE( x )

return P_CODES[ x ]

*+
*+
*+    Procedure PR_UNSET()
*+
*+
*+
procedure PR_UNSET()

local x := P_CODES[ 47 ]
local Y := P_CODES[ 48 ]

afill( P_CODES, '' )

P_CODES[ 47 ] := x
P_CODES[ 48 ] := Y

return

*+
*+
*+    Procedure PR_RESET()
*+
*+
*+
procedure PR_RESET()

P_CODES := aclone( PRNT_SAVE )

return

*+
*+
*+    Procedure PR_HIDE()
*+
*+
*+
procedure PR_HIDE()

P_CODES := aclone( PRNT_HIDE )

return

*+
*+
*+    Procedure SLIP_INIT()
*+
*+
*+
procedure SLIP_INIT()

local THIS_SET
local x

use SLIP new

THIS_SET := gete( 'SPRINTER' )

if !dbseek( THIS_SET ) .or. empty( THIS_SET )               // use the default DP8340
   go 1
endif

for x := 1 to 15
   S_CODES[ X ] := PR_DECODE( fieldget( x ) )
next

SLIP_SAVE := aclone( S_CODES )

SLIP->( dbclosearea() )

return

*+
*+
*+    Function S_CODE()
*+
*+
*+
function S_CODE( x )

return S_CODES[ x ]

*+
*+
*+    Procedure SL_UNSET()
*+
*+
*+
procedure SL_UNSET()

local x := S_CODES[ 14 ]
local Y := S_CODES[ 15 ]

afill( S_CODES, '' )

S_CODES[ 14 ] := x
S_CODES[ 15 ] := Y

return

*+
*+
*+    Procedure SL_RESET()
*+
*+
*+
procedure SL_RESET()

S_CODES := aclone( SLIP_SAVE )

return

*+
*+
*+    Static Function PR_DECODE()
*+
*+    Called from ( sample.prg   )   1 - procedure print_init()
*+                                   1 - procedure slip_init()
*+
*+
*+
static function PR_DECODE( FIELD_DATA )

local OUT_STRING := ''
local SEP_AT
local SEP_END
local DEC_DATA

begin sequence

   if islogic( FIELD_DATA ) .or. isnumber( FIELD_DATA )
      OUT_STRING := FIELD_DATA
      break
   endif

   FIELD_DATA := alltrim( FIELD_DATA )

   if len( FIELD_DATA ) > 0
      do while .t.
         SEP_AT := at( '{', FIELD_DATA )
         do case
         case SEP_AT == 0
            OUT_STRING += FIELD_DATA
            exit
         case SEP_AT == 1
            SEP_END    := at( "}", FIELD_DATA )
            DEC_DATA   := substr( FIELD_DATA, 2, SEP_END - 1 )
            OUT_STRING += chr( val( DEC_DATA ) )
            FIELD_DATA := substr( FIELD_DATA, SEP_END + 1 )
         case SEP_AT > 1
            OUT_STRING += left( FIELD_DATA, SEP_AT - 1 )
            FIELD_DATA := substr( FIELD_DATA, SEP_AT )
         endcase
      enddo
   endif

end sequence

return OUT_STRING

*+
*+
*+    Function ALIGN()
*+
*+    Called from ( sample.prg   )   1 - procedure prn_test()
*+
*+
*+
function ALIGN

POP_MSG( 'Align the paper.  <Esc> to abort.' )
if !isprinter() .and. !lastkey() = 27
   POP_MSG( { "The printer is either off or offline.", "I'll Wait while You fix it!" }, .f. )
   do while !isprinter() .and. !lastkey() = 27
      inkey( .5 )
   enddo
   clr_msg()
endif

return !lastkey() = 27

*+ EOF: SAMPLE.PRG
